// GANDHARA (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
	char fname[FILENAME_MAX];
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	unsigned char id[] = "GANDHARA-X1  Sys";
	int i,d;

	struct fpos md1[] = {
		{ 0x3e, 0x05, 0x1000, "DRIVER" },
		{ 0x4f, 0x01, 0x0800, "DEAD" },
		{ 0x3f, 0x04, 0x2200, "WORLD1A" },
		{ 0x49, 0x08, 0x1000, "DUNGEON" },
		{ 0x39, 0x04, 0x4d00, "MENU" },
		{ 0x42, 0x08, 0x1d00, "HEIAN" },
		{ 0x41, 0x08, 0x1000, "NINGEN" },
		{ 0x44, 0x05, 0x1100, "JIGOKU" },
		{ 0x45, 0x06, 0x0f00, "GAKI" },
		{ 0x46, 0x05, 0x1200, "CHIKUSHO" },
		{ 0x47, 0x06, 0x1100, "SHURA" },
		{ 0x48, 0x07, 0x1100, "TENJO" },
		{ 0x4e, 0x06, 0x0b00, "ENDING" },
		{ 0x4d, 0x10, 0x0600, "EPILOGUE" },
//		{ 0x4d, 0x0c, 0x0400, "INTRO" },
		{ 0x00, 0x00, 0x0000, "" }, // End of Data
	};

	struct fpos md2[] = {
		{ 0x4e, 0x01, 0x1b00, "OPENING" },
		{ 0x00, 0x00, 0x0000, "" }, // End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBXN
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if (!memcmp(&buff[1], id, sizeof(id)-1)) {
			printf("Disk AF܂.\n");
			for (i=0; md1[i].sec; i++) {
				fcut(md1[i].fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
		}
		else {
			printf("Disk BƂĐ؂osȂ܂.\n");
			for (i=0; md2[i].sec; i++) {
				fcut(md2[i].fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
		}
	}
	return 0;
}

